#include "stc8h.h"
#include "intrins.h"

//#define I2CCFG      (*(unsigned char volatile xdata *)0xfe80)
//#define I2CMSCR     (*(unsigned char volatile xdata *)0xfe81)
//#define I2CMSST     (*(unsigned char volatile xdata *)0xfe82)
//#define I2CSLCR     (*(unsigned char volatile xdata *)0xfe83)
//#define I2CSLST     (*(unsigned char volatile xdata *)0xfe84)
//#define I2CSLADR    (*(unsigned char volatile xdata *)0xfe85)
//#define I2CTXD      (*(unsigned char volatile xdata *)0xfe86)
//#define I2CRXD      (*(unsigned char volatile xdata *)0xfe87)

sbit    SDA     =   P1^4;
sbit    SCL     =   P1^5;

#define FOSC        11059200UL
#define BRT         (65536 - FOSC / 115200 / 4)

void Wait()
{
    while (!(I2CMSST & 0x40));
    I2CMSST &= ~0x40;
}

void Start()
{
    I2CMSCR = 0x01;                             //START
    Wait();
}

void SendData(char dat)
{
    I2CTXD = dat;                               //дݵݻ
    I2CMSCR = 0x02;                             //SEND
    Wait();
}

void RecvACK()
{
    I2CMSCR = 0x03;                             //ͶACK
    Wait();
}

char RecvData()
{
    I2CMSCR = 0x04;                             //RECV
    Wait();
    return I2CRXD;
}

void SendACK()
{
    I2CMSST = 0x00;                             //ACKź
    I2CMSCR = 0x05;                             //ACK
    Wait();
}

void SendNAK()
{
    I2CMSST = 0x01;                             //NAKź
    I2CMSCR = 0x05;                             //ACK
    Wait();
}

void Stop()
{
    I2CMSCR = 0x06;                             //STOP
    Wait();
}

void Delay()
{
    int i;

    for (i=0; i<3000; i++)
    {
        _nop_();
        _nop_();
        _nop_();
        _nop_();
    }
}

void UartInit()
{
    SCON = 0x5a;
    T2L = BRT;
    T2H = BRT >> 8;
    AUXR = 0x15;
}

void UartSend(char dat)
{
    while (!TI);
    TI = 0;
    SBUF = dat;
}

void main()
{
    P0M0 = 0x00;
    P0M1 = 0x00;
    P1M0 = 0x00;
    P1M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;
    P3M0 = 0x00;
    P3M1 = 0x00;
    P4M0 = 0x00;
    P4M1 = 0x00;
    P5M0 = 0x00;
    P5M1 = 0x00;

    P_SW2 = 0x80;

    I2CCFG = 0xe0;                              //ʹI2Cģʽ
    I2CMSST = 0x00;
       
                UartInit();

       Start();                                    //ʼ------------------------------->ע͵Ϳ
//    SendData(0xa2);                             //豸ַ+д
//    RecvACK();
//    SendData(0x02);                             //ʹ洢ַ
//    RecvACK();
//    SendData(0x00);                             //ֵ
//    RecvACK();
//    SendData(0x00);                             //÷ֵ
//    RecvACK();
//    SendData(0x12);                             //Сʱֵ
//    RecvACK();
//    Stop();                                     //ֹͣ

    while (1)
    {
                        UartSend(0x55);
//        Start();                                //ʼ
//        SendData(0xa2);                         //豸ַ+д
//        RecvACK();
//        SendData(0x02);                         //ʹ洢ַ
//        RecvACK();
//        Start();                                //ʼ
//        SendData(0xa3);                         //豸ַ+
//        RecvACK();
//        P0 = RecvData();                        //ȡֵ
//        SendACK();
//        P2 = RecvData();                        //ȡֵ
//        SendACK();
//        P3 = RecvData();                        //ȡСʱֵ
//        SendNAK();
//        Stop();                                 //ֹͣ

//        Delay();
    }
}
